/* 
   Projeto de MAC 5759
   
   Alunos: Livio Baldini Soares <livio@ime.usp.br>                  No. USP: 2869100
   Mrcio Rodrigo de Freitas Carneiro <carneiro@ime.usp.br> No. USP: 2868836
   Roberto Pires de Carvalho <carvalho@ime.usp.br>          No. USP: 2869559
   Data: 5/7/2002
*/


#include <mico/CosNaming.h>
#include <iostream.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/utsname.h>
#include <sys/stat.h>
#include <sys/poll.h>
#include <sys/types.h>
#include <sys/vfs.h>
#include <sys/time.h>

#include <signal.h>
#include <errno.h>
#include <stack.h>
#include <string.h>
#include <fcntl.h>

#include <readline/readline.h>
#include <readline/history.h>

#include <linux/types.h>
#include <linux/dirent.h>
#include <linux/unistd.h>

// #include <asm/page.h>

#include "CFS.h"
#include "CFSimpl.h"

extern "C" void *threadORBRunStartupHelper(void *arg);
extern "C" void *threadDaemonStartupHelper(void *arg);

#define CHRONO_START()      gettimeofday(&inicio, NULL);
#define CHRONO_STOP(name)                                                                \
    gettimeofday(&fim, NULL);                                                            \
    timersub(&fim, &inicio, &diff);                                                      \
    cout << "Time of " << name << " " << diff.tv_sec*1000000 + diff.tv_usec << endl;    \

/* Defines the device prefix */
#define DEVICE "/dev/devfs/cfs/"

/* Which local directory to use as "root" */
#define CFS_NAME_LEN         255
#define MAX_CFSDEVS          1    /* How many do we allow */

/*
 * Attribute flags.  These should be or-ed together to figure out what
 * has been changed!
 */
#define ATTR_MODE       1
#define ATTR_UID        2
#define ATTR_GID        4
#define ATTR_SIZE       8
#define ATTR_ATIME      16
#define ATTR_MTIME      32
#define ATTR_CTIME      64
#define ATTR_ATIME_SET  128
#define ATTR_MTIME_SET  256
#define ATTR_FORCE      512   /* Not a change, but a change it */
#define ATTR_ATTR_FLAG  1024


/* Kernel <-> CORBA daemon communication */
#define CFS_STATFS            2
#define CFS_LOOKUP            3
#define CFS_READPAGE          4
#define CFS_FILE_WRITE        5
#define CFS_WRITEPAGE         6
#define CFS_PREPARE_WRITE     7
#define CFS_COMMIT_WRITE      8
#define CFS_READ_INODE        9
#define CFS_FORCE_DELETE     10
#define CFS_MKNOD            11
#define CFS_MKDIR            12
#define CFS_CREATE           13
#define CFS_LINK             14
#define CFS_POSITIVE         15
#define CFS_EMPTY            16
#define CFS_UNLINK           17
#define CFS_RMDIR            18
#define CFS_RENAME           19
#define CFS_SYMLINK          20
#define CFS_READLINK         21
#define CFS_SYNC_FILE        22
#define CFS_READDIR          23
#define CFS_SETATTR          24
#define CFS_READ_SUPER       25


struct cfs_downcall {
    unsigned int type;    /* might be unneeded? */
    unsigned int unique;
    int error;
    
    union {
	struct statfs  statfs;       /* statfs */
	struct {
	    unsigned short st_dev;
	    unsigned short __pad1;
	    unsigned long st_ino;
	    unsigned short st_mode;
	    unsigned short st_nlink;
	    unsigned short st_uid;
	    unsigned short st_gid;
	    unsigned short st_rdev;
	    unsigned short __pad2;
	    unsigned long  st_size;
	    unsigned long  st_blksize;
	    unsigned long  st_blocks;
	    unsigned long  st_atime;
	    unsigned long  __unused1;
	    unsigned long  st_mtime;
	    unsigned long  __unused2;
	    unsigned long  st_ctime;
	    unsigned long  __unused3;
	    unsigned long  __unused4;
	    unsigned long  __unused5;
	}  stat;                      /* read_inode */
	struct {
	    unsigned int    ndir;
	    struct dirent   *dirp;
	} readdir;                    /* readdir */
	struct {
	    unsigned int    nbytes;
	    char              *buf;
	} readpage;                   /* readpage */
	/* commitwrite null */
	/* mknod       null */
	/* unlink      null */
	/* rename      null */
	struct {
	    int              nbytes;
	    char             *buf;
	} readlink;
	/* setattr     null */
    } u;
};

struct cfs_upcall {
    unsigned int type;
    unsigned int unique;
    
    union {
	struct {
	    /* null */
	} statfs; 
	struct {
	    char inodename[CFS_NAME_LEN];  /* read_inode */
	} readinode;
	struct {
	    char dirname[CFS_NAME_LEN];
	    unsigned long  file_offset;
	} readdir;
	struct {
	    char filename[CFS_NAME_LEN];
	    unsigned long file_offset;     /* readpage   */
	} readpage;
	struct {
	    char             filename[CFS_NAME_LEN];
	    unsigned long    file_offset;  
	    unsigned int     nbytes;
	    char               *buf;
	} commitwrite;                   /* commitwrite */
	struct {
	    char             inodename[CFS_NAME_LEN];
	    int              mode;
	    int              dev;
	} mknod;                         /* mknod */
	struct {
	    char             inodename[CFS_NAME_LEN];
	    int              mode;
	} unlink;                        /* unlink */
	struct {
	    char             oldpath[CFS_NAME_LEN];
	    char             newpath[CFS_NAME_LEN];
	} rename;                        /*  rename */
	struct {
	    char             linkname[CFS_NAME_LEN];
	} readlink;                      /* readlink */
	struct {
	    char             oldpath[CFS_NAME_LEN];
	    char             newpath[CFS_NAME_LEN];
	} symlink;                          /* symlink  */
	struct {
	    char             inodename[CFS_NAME_LEN];
	    struct iattr {
		unsigned int  ia_valid;
		umode_t       ia_mode;
		uid_t         ia_uid;
		gid_t         ia_gid;
		loff_t        ia_size;
		time_t        ia_atime;
		time_t        ia_mtime;
		time_t        ia_ctime;
		unsigned int  ia_attr_flags;
	    }  attr;
	} setattr;                          /* setattr  */
    } u;
};


/* GLOBAL, yes... */
timeval inicio, fim, diff;

namespace CFS {

    class CFSd_impl : public virtual POA_CFS::CFSd
    {
	public:
	CFSd_impl() {
	    orb = NULL;
	}

	CFSd_impl(CORBA::ORB_var the_orb) {
	    try {    
		// Initialize orb
		orb = the_orb;

		// Get reference to Root POA.
		CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
		PortableServer::POA_var poa = PortableServer::POA::_narrow(obj);
		    
		// Activate POA manager
		poa->the_POAManager()->activate();

		//Get reference to NameServices
		obj = orb->resolve_initial_references("NameService");
		CosNaming::NamingContext_var root_context = CosNaming::NamingContext::_narrow(obj);
		assert(!CORBA::is_nil(root_context));

		superblock = createContextSB(root_context, orb);
	    }
	    catch (CORBA::Exception e) {
		e._print(cerr);
		cerr << endl;
		cerr << "(CFSd) Uncaught CORBA exception" << endl;
	    }
	}

	void run(int psdev) {
	    char device[strlen(DEVICE)+2];
	    struct pollfd ufds;
	    struct cfs_upcall upcall;
	    struct cfs_downcall downcall;
	    int fd, nbytes, size, free_buf = 0;
	    char *buf, in[PAGE_SIZE + sizeof(struct cfs_upcall)];

	    sprintf(device, "%s%d", DEVICE, psdev);
	    cout << "Thread " << psdev << ": device=" << device << endl;
	    
	    if ((fd = open(device, O_RDWR)) == -1) {
		cout << "Thread " << psdev << ": Invalid file." << endl;
		cout << "Error: " << strerror(errno) << endl;
		return;
	    }

	    ufds.fd = fd;
	    ufds.events = POLLIN;
	    ufds.revents = 0;
	    
	    while(1) {

		if (poll(&ufds, 1, -1) < 0)
		    printf("Erro: %s\n", strerror(errno));

		if (!(ufds.revents & POLLIN)) continue;

		nbytes = read(fd, &in, sizeof(struct cfs_upcall)+PAGE_SIZE);
		memcpy(&upcall,  in, sizeof(struct cfs_upcall));

		printf("Conseguir ler %d bytes, type=%d, unique=%d, U_SIZE=%d, D_SIZE=%d\n",
		       nbytes, upcall.type, upcall.unique, sizeof(struct cfs_upcall), sizeof(struct cfs_downcall));

		downcall.type = upcall.type;
		downcall.unique = upcall.unique;
		downcall.error = 0;
		buf = (char*) &downcall;
		size = sizeof(struct cfs_downcall);
		free_buf = 0;

		switch (upcall.type) {
		case CFS_STATFS:
		    {
			Statfs buf;
			int error = superblock->statfs("/", buf);

			if (error) {
			    cout << "Error in statfs: " << strerror(error) << endl;
			    downcall.error = -error;
			}
			
			downcall.u.statfs.f_type    = buf.f_type;
			downcall.u.statfs.f_bsize   = buf.f_bsize;
			downcall.u.statfs.f_blocks  = buf.f_blocks;
			downcall.u.statfs.f_bfree   = buf.f_bfree;
			downcall.u.statfs.f_bavail  = buf.f_bavail;
			downcall.u.statfs.f_files   = buf.f_files;
			downcall.u.statfs.f_ffree   = buf.f_ffree;
			memcpy(&downcall.u.statfs.f_fsid, &buf.f_fsid, 8);
			downcall.u.statfs.f_namelen = buf.f_namelen;
			break;
		    }
    		case CFS_READ_INODE:
		    {
			Inode_var inode = NULL;
			cout << "Trying to find " << upcall.u.readinode.inodename << endl;
			int error = superblock->read_inode(upcall.u.readinode.inodename, inode);
			if (error) {
			    cout << "Error in read_inode: " << strerror(error) << endl;
			    downcall.error = -error;
			    break;
			}
			downcall.u.stat.st_dev     = inode->i_dev;
			downcall.u.stat.st_ino     = inode->i_ino;
			downcall.u.stat.st_mode    = inode->i_mode;
			downcall.u.stat.st_nlink   = inode->i_nlink;
			downcall.u.stat.st_uid     = inode->i_uid;
			downcall.u.stat.st_gid     = inode->i_gid;
			downcall.u.stat.st_rdev    = inode->i_rdev;
			downcall.u.stat.st_size    = inode->i_size;
			downcall.u.stat.st_blksize = inode->i_blksize;
			downcall.u.stat.st_blocks  = inode->i_blocks;
			downcall.u.stat.st_atime   = inode->i_atime;
			downcall.u.stat.st_mtime   = inode->i_mtime;
			downcall.u.stat.st_ctime   = inode->i_ctime;
			break;
		    }
		case CFS_READDIR:
		    {
			int error = 0;
			Dirents_var dir; 
			error = superblock->readdir(upcall.u.readdir.dirname, dir);
			
			if(error) {
			    downcall.error = -error;
			    downcall.u.readdir.ndir = 0;
			    break;
			}
			
			nbytes = 0;
			struct dirent *dirp = (struct dirent *)malloc(1024*sizeof(struct dirent));
			struct dirent *dirlist = dirp;
			int offset = 0;
			for(unsigned i = 0; i < dir->length(); i++) {
			    dirlist->d_ino = dir[i].d_ino;
			    dirlist->d_name[0] = 0;
			    strcat(dirlist->d_name, CORBA::string_dup(dir[i].d_name));
			    
			    dirlist->d_reclen = sizeof(long) + sizeof(off_t) + sizeof(unsigned short) + strlen(dirlist->d_name) + 1;
			    
			    if (dirlist->d_reclen % 4) 
				dirlist->d_reclen += 4 - (dirlist->d_reclen % 4);
			    
			    // It's impossible to understand this thing!
			    if (i == dir->length() - 1) {
				dirlist->d_off = 4096;
			    }
			    else {
				dirlist->d_off = offset + dirlist->d_reclen;
				offset = dirlist->d_off;
			    }
			    
			    nbytes += dirlist->d_reclen;
			    dirlist = (struct dirent *) ((char*) dirlist + dirlist->d_reclen);
			}

			downcall.u.readdir.ndir = nbytes;

			size = sizeof(struct cfs_downcall) + downcall.u.readdir.ndir;
			buf = (char*) malloc(size);
			memcpy(buf, &downcall, sizeof(struct cfs_downcall));
			memcpy(buf+sizeof(struct cfs_downcall), dirp, downcall.u.readdir.ndir);
			free(dirp);
			free_buf = 1;
			
			break;
		    }
		case CFS_READPAGE:
		    {
                        // Primeiro vamos ao CORBA
                        Page page;
                        int error = 0;
                        unsigned int size;
                        error = superblock->read_page(upcall.u.readpage.filename, upcall.u.readpage.file_offset, page);

                        if(error) {
			    downcall.u.readpage.nbytes = 0;
                            downcall.error = -error;
                            break;
                        }
			
			downcall.u.readpage.nbytes = page.nbytes;

                        // E agora ao kernel
                        size = sizeof(struct cfs_downcall) + downcall.u.readpage.nbytes;
                        buf = (char*) malloc(size);
			
                        memcpy(buf, &downcall, sizeof(struct cfs_downcall));
                        memcpy(buf + sizeof(struct cfs_downcall), page.data, downcall.u.readpage.nbytes);
                        free_buf = 1;
			
                        break;
		    }
		case CFS_COMMIT_WRITE:
		    {
			// Primeiro vamos ao CORBA
			Page page;
			
			page.nbytes = upcall.u.commitwrite.nbytes;
                        memcpy (page.data, (void*) (in + sizeof(struct cfs_upcall)), page.nbytes);
                        int error = 0;
                        error = superblock->commit_write(upcall.u.commitwrite.filename, upcall.u.commitwrite.file_offset, page);
			
                        if(error)
                            downcall.error = -error;

                        break;
		    }
		case CFS_MKNOD:
		    {
			int error = 0;

			if (S_ISDIR(upcall.u.mknod.mode))
			    error = superblock->mkdir(upcall.u.mknod.inodename, (unsigned short) upcall.u.mknod.mode);
			else 
			    error = superblock->mknod(upcall.u.mknod.inodename, (unsigned short) upcall.u.mknod.mode, 
						      (unsigned short) upcall.u.mknod.dev);

			if(error)
                            downcall.error = -error;

			break;
		    }
		case CFS_SYMLINK:
		    {
			int error = 0;

			error = superblock->symlink(upcall.u.symlink.oldpath, upcall.u.symlink.newpath);
			
			if(error)
                            downcall.error = -error;

			break;
		    }
		case CFS_READLINK:
		    {
			Page page;
			int error;
			
			if ((error = superblock->read_link(upcall.u.readlink.linkname, page)) == -1) {
			    downcall.u.readlink.nbytes = 0;
			    downcall.error = -error;
			    break;
			}

			page.data[page.nbytes++] = 0;
			downcall.u.readlink.nbytes = page.nbytes;

			size = sizeof(struct cfs_downcall) + downcall.u.readlink.nbytes;
			buf = (char *)malloc(size);
	
			memcpy(buf, &downcall, sizeof(struct cfs_downcall));
			memcpy(buf+sizeof(struct cfs_downcall), page.data, downcall.u.readlink.nbytes);
			free_buf = 1;

			break;
		    }
		case CFS_UNLINK:
		    {
			int error = 0;

			if (S_ISDIR(upcall.u.unlink.mode)) 
			    error = superblock->rmdir(upcall.u.unlink.inodename);
			else 
			    error = superblock->unlink(upcall.u.unlink.inodename);
			
			if (error)
			    downcall.error = -error;

			break;
		    }
		case CFS_RENAME:
		    {
			int error = 0;

			error = superblock->rename(upcall.u.symlink.oldpath, upcall.u.symlink.newpath);
			
			if(error)
                            downcall.error = -error;

			break;
		    }
		case CFS_SETATTR:
		    {
			unsigned int ia_valid = upcall.u.setattr.attr.ia_valid;
			
			int error = 0;
			Inode_var inode;

			if (ia_valid & ATTR_UID || ia_valid & ATTR_GID) {
			    if (!(ia_valid & ATTR_GID))
				upcall.u.setattr.attr.ia_gid = -1;
			    if (!(ia_valid & ATTR_UID))
				upcall.u.setattr.attr.ia_uid = -1;
			    
			    error = superblock->chown(upcall.u.setattr.inodename, 
						      upcall.u.setattr.attr.ia_uid, upcall.u.setattr.attr.ia_gid);
			    if (error) {
				downcall.error = -error;
				break;
			    }
			}
			
			if (ia_valid & (ATTR_ATIME | ATTR_MTIME)) {
			    error = superblock->utime(upcall.u.setattr.inodename, 
						      upcall.u.setattr.attr.ia_atime, upcall.u.setattr.attr.ia_mtime);
			    if (error) {
				downcall.error = -error;
				break;
			    }
			}

			if (ia_valid & ATTR_MODE) {
			    error = superblock->chmod(upcall.u.setattr.inodename, upcall.u.setattr.attr.ia_mode);
			    if (error) {
				downcall.error = -errno;
				break;
			    }
			}
			break;
		    }
		default:
		    cout << "Oh, oh! Not implemented! :-/" << endl;
		}
		
		if ((nbytes = write(fd, buf, size)) < 0)
		    cout << "Error in writing to device: " << strerror(errno) << endl;
		else 
		    cout << "Yes! I wrote " << nbytes << " bytes." << endl;
		
		if (free_buf)
		    delete buf;
	    }
	}
	    
	private:
	    CORBA::ORB_var orb;
	    Superblock_var superblock;
    };
};
	  
void *threadDaemonStartupHelper(void *arg)
{
    static int psdev = 0;
    CFS::CFSd_impl *cfsd = (CFS::CFSd_impl*) arg;
    cfsd->run(psdev++);
    return NULL; // not reached? 
}

int main (int argc, char *argv[])
{
    //    daemon(TRUE, TRUE);

    pthread_t daemon_thread[MAX_CFSDEVS];
    CFS::CFSd_impl *cfsd = new CFS::CFSd_impl(CORBA::ORB_init(argc, argv));

    for (int i = 0; i < MAX_CFSDEVS; i++) {
	pthread_create(&daemon_thread[i], NULL, threadDaemonStartupHelper, cfsd);
    }
    
    pthread_join(daemon_thread[0], NULL);
    return 0;
}
